#!/usr/bin/env perl
#
#  Copyright 1996-2011 Jim Pirzyk / pirzyk.org
#  All rights reserved.
#
#  common.t - Routines common to setting up test cases.
#

package t::common;

use Exporter;
use strict;
use warnings "all";

our @ISA = qw(Exporter);
our %EXPORT_TAGS = ( 'all' => [ qw(
	create_file
) ] );
our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} });
our @EXPORT = ( @{ $EXPORT_TAGS{'all'} });

our @FILES;

sub create_file {
	my ($file, $uid, $gid, $mode, $content) = @_;
	my ($FP);

	open ($FP, "> $file") || die "Could not create test file ($file)\n";
	print $FP $content if ( defined $content );
	close $FP;

	# If we want non default uid/gids...
	if ( $( != $gid || $uid != -1 || $gid != -1 ) {
		if ( $< == 0 ) {
			chown $uid, $gid, $file || die "Could not chown file ($file)\n";
		} else {
			chown -1, $gid, $file || die "Could not chgrp file ($file)\n";
		}
	}

	chmod $mode, $file if ( defined $mode );

	push @FILES, $file;
}

1;
